
#ifndef __clientuserjavaadapter_h__
#define __clientuserjavaadapter_h__


#include "error.h"
#include "stdhdrs.h"
#include "strbuf.h"
#include "filesys.h"
#include "clientuser.h"
#include <jni.h>

class ClientUserJavaAdapter : public ClientUser {

    public:
			ClientUserJavaAdapter(JNIEnv * env, jobject peer);

	virtual void	InputData(StrBuf *strbuf, Error *e);

	virtual void 	HandleError(Error *err);
	virtual void 	OutputError(char *errBuf);
	virtual void	OutputInfo(char level, const_char *data);
	virtual void 	OutputBinary(const_char *data, int length);
	virtual void 	OutputText(const_char *data, int length);

	virtual void	OutputStat(StrDict *varList);

	virtual void	Prompt(const StrPtr &msg, StrBuf &rsp, int noEcho, Error *e);
	virtual void	ErrorPause(char *errBuf, Error *e);

	virtual void	Edit(FileSys *f1, Error *e);
	void	InheritedEdit(FileSys *f1, Error *e);

	virtual void	Diff(FileSys *f1, FileSys *f2, int doPage, 
				char *diffFlags, Error *e);

	void	InheritedDiff(FileSys *f1, FileSys *f2, int doPage, 
				char *diffFlags, Error *e);

	virtual void	Merge(FileSys *base, FileSys *leg1, FileSys *leg2, 
			      FileSys *result, Error *e);

	void	InheritedMerge(FileSys *base, FileSys *leg1, FileSys *leg2, 
			       FileSys *result, Error *e);

	virtual void	Help(const_char *const *help);

	virtual void	Finished(JNIEnv * env);
	
	void ReleaseGlobalRef(JNIEnv * env);

    private:
	jobject javaPeer;
	JNIEnv * javaEnv;
	
	jmethodID GetMethod(JNIEnv * env, char * name, char * signature);
} ;

#endif /* #ifndef __clientuserjavaadapter_h__ */
