package com.perforce.jdev;

import javax.swing.Icon;
import javax.swing.KeyStroke;

import oracle.ide.scm.SCMControlItem;
import oracle.ide.scm.SCMFile;
import oracle.ide.scm.SCMFileStatus;
import oracle.ide.scm.SCMOptions;
import oracle.ide.scm.error.SCMException;
import oracle.ide.scm.op.SCMSingleFileOperation;

import com.perforce.api.Env;
import com.perforce.jdev.res.Icons;

public class P4AddCmd extends SCMSingleFileOperation implements SCMControlItem {
   public void execute(SCMFile sf, SCMOptions opts) throws SCMException {
      final SCMFileStatus stat = sf.getStatus();
      final P4File f = (stat instanceof P4File) ? (P4File) stat :
         new P4File(sf, new Env()); // XXX
      f.openForAdd(opts);
   }

   public boolean filter(SCMFile f) throws SCMException {
      if (f.isDirectory() || f.isReadOnly()) return false;
      final SCMFileStatus stat = f.getStatus();
      return !stat.isControlled();
   }

   public SCMControlItem getControlItem() {
      return this;
   }

   public String getName() {
      return "p4 add";
   }

   public char getMnemonic() {
      return 'a';
   }

   public KeyStroke getAccelerator() {
      return null;
   }

   public Icon getIcon() {
      return Icons.ADD;
   }

   public boolean isContextItem() {
      return true;
   }

}